/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';
const agentEmitter = require('../../../agent-emitter');
const {
  constants: { EVENTS },
  utils: { getHidden }
} = require('../../../core/fastify');
const { emitSendEvent } = require('../../../hooks/frameworks/common');

class FastifyResponseScanning {
  constructor() {
    this.registerResponseScanningHandler();
  }

  /**
   * registers a fastify `onSend` hook to emit a `send` event
   * for response scanning assess rules
   */
  registerResponseScanningHandler() {
    agentEmitter.on(EVENTS.ON_SEND, (request, reply, payload) => {
      const headers = this.getResponseHeaders(reply);
      emitSendEvent(payload, headers);
    });
  }

  /**
   * Gets response headers from the `reply` instance. Favor `reply.raw` over
   * `reply.res` since the latter is deprecated in newer fastify versions.
   * @param {object} reply fastify reply instance
   * @returns {object}
   */
  getResponseHeaders(reply) {
    const res = reply.raw || reply.res;
    return {
      ...res.getHeaders(), // capture headers set with ServerResponse.setHeader()
      ...getHidden(reply, 'fasitfy.reply.headers')
    };
  }
}

module.exports = FastifyResponseScanning;
